"use strict";

var gulp        = require( "gulp"              );
gulp            = require( "gulp-help" )( gulp );
var tsc         = require( "gulp-typescript"   );
var merge       = require( "merge2"            );

// Setup the plumber to help with errors
//
var plumber      = require( "gulp-plumber" );
var gutil        = require( "gulp-util"    );
var onError      = function ( error ) {
    gutil.beep();
    // console.log( error );
};

gulp.task( "tsc", "Compiles all TypeScript source files using settings from tsconfig.json", function ()
{
    var tsProject = tsc.createProject( "tsconfig.json", {
        typescript: require( "typescript" )
    } );

    var tsResult = tsProject.src()
    .pipe( plumber( { errorHandler: onError } ) )
    .pipe( tsProject() );

    return merge( [
        tsResult.dts.pipe( gulp.dest( "./src" ) ),
        tsResult.js.pipe(  gulp.dest( "./src" ) )
    ] );
} );
