"use strict";

var pkg         = require( "../package.json"  );
var tsConfig    = require( "../tsconfig.json" );
var typedoc     = require( 'gulp-typedoc'     );
var gulp        = require( "gulp"             );
gulp            = require( "gulp-help" )( gulp );

var tsConfig    = require( "../tsconfig.json" );
var tsFilesGlob = ( function ( c )
{
    return c.filesGlob || c.files || "**/*.ts";
} )( tsConfig );

gulp.task( "typedoc", "Generates TypeDoc based documentation", [ "clean_docs", "tsconfig_files", "tslint" ], function()
{
	return gulp
		.src( tsFilesGlob )
		.pipe( typedoc(
        {
			// TypeScript options (see typescript docs)
			//
			module              : tsConfig.compilerOptions.module,
			target              : tsConfig.compilerOptions.target,
			includeDeclarations : true,

			// Output options (see typedoc docs)
			//
			out                 : "./docs",
			json                : "./docs/" + pkg.name + ".json",

			// TypeDoc options (see typedoc docs)
			//
			name                : pkg.name,
			ignoreCompilerErrors: true,
			version             : true
		} )
    );
} );
