/* tslint:disable:max-classes-per-file */
/* tslint:disable:variable-name */
/* tslint:disable:no-trailing-whitespace */
/* tslint:disable:no-consecutive-blank-lines */
/* tslint:disable:no-namespace */
/* tslint:disable:member-access */
/* tslint:disable:typedef-whitespace */
/* tslint:disable:no-internal-module */

declare module EVA.BI {
  
  export enum AggregationTypes {
    Sum = 0,
    WeightedAverage = 1,
    SumLast = 2,
  }
  
  export class Data {
    Label : string; 
    Value : number; // Decimal
    Target? : number; // Decimal, nullable
    AccumulatedValue : number; // Decimal
  }
  
  export class Dataset {
    Name : string; 
    Label : string; 
    OrganizationUnitID? : number; // Int32, nullable
    OrganizationUnitName : string; 
    Series : EVA.BI.Series; 
    Actual : number; // Decimal
    Target? : number; // Decimal, nullable
    Data : EVA.BI.Data[]; 
  }
  
  export class GetData extends EVA.API.RequestMessageGeneric<EVA.BI.GetDataResponse> {
    OrganizationUnitID : number; // Int32
    Labels : string[]; 
    Timeframe : EVA.BI.Timeframe; 
    Series : EVA.BI.Series[]; 
    GroupBy : EVA.BI.GroupBy; 
    Mock? : boolean; 
  }
  
  export class GetDataResponse extends EVA.API.GetListResponse<EVA.BI.Dataset> {
  }
  
  export class GetLabels extends EVA.API.GetRequestGeneric<EVA.BI.GetLabelsResponse> {
  }
  
  export class GetLabelsResponse extends EVA.API.GetListResponse<EVA.BI.Label> {
  }
  
  export class GetSalesBudgets extends EVA.API.RequestMessageGeneric<EVA.API.ResourceResponseMessage> {
  }
  
  export enum Grain {
    None = 0,
    Days = 1,
    Weeks = 2,
    Months = 3,
  }
  
  export enum GroupBy {
    Label = 0,
    OrganizationUnit = 1,
    Name = 2,
  }
  
  export class Label {
    Name : string; 
    Type : EVA.BI.LabelTypes; 
    AggregationType : EVA.BI.AggregationTypes; 
  }
  
  export enum LabelTypes {
    Default = 0,
    Singular = 1,
  }
  
  export enum Series {
    Actual = 0,
    LFL = 1,
  }
  
  export class Timeframe {
    Period : any; 
    Range : any; 
    Date? : string; // DateTime, nullable
  }
  
  export class UpdateSalesBudgets extends EVA.API.RequestMessageWithEmptyResponse {
    Data : string; 
  }
  
}